package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.query.QueryRuleEnum;
import org.jeecg.modules.database.entity.ExperimentSampleInfo;
import org.jeecg.modules.database.service.IExperimentSampleInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * @Description: 试验样品信息
 * @Author: jeecg-boot
 * @Date: 2024-12-04
 * @Version: V1.0
 */
@Tag(name = "试验样品信息")
@RestController
@RequestMapping("/database/experimentSampleInfo")
@Slf4j
public class ExperimentSampleInfoController extends JeecgController<ExperimentSampleInfo, IExperimentSampleInfoService> {
    @Autowired
    private IExperimentSampleInfoService experimentSampleInfoService;

    /**
     * 分页列表查询
     *
     * @param experimentSampleInfo
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "试验样品信息-分页列表查询")
    @Operation(summary = "试验样品信息-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ExperimentSampleInfo>> queryPageList(ExperimentSampleInfo experimentSampleInfo,
                                                             @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                             @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                             HttpServletRequest req) {
        QueryWrapper<ExperimentSampleInfo> queryWrapper = QueryGenerator.initQueryWrapper(experimentSampleInfo, req.getParameterMap());
        Page<ExperimentSampleInfo> page = new Page<ExperimentSampleInfo>(pageNo, pageSize);
        IPage<ExperimentSampleInfo> pageList = experimentSampleInfoService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    @Operation(summary = "试验样品信息-列表查询样品型号")
    @GetMapping(value = "/listSampleModel")
    public Result<List<ExperimentSampleInfo>> listSampleModel(HttpServletRequest req) {
        List<ExperimentSampleInfo> pageList = experimentSampleInfoService.listSampleModel();
        return Result.OK(pageList);
    }

    @Operation(summary = "试验样品信息-列表查询样品批次")
    @GetMapping(value = "/listSampleBatch")
    public Result<List<ExperimentSampleInfo>> listSampleBatch(HttpServletRequest req) {
        List<ExperimentSampleInfo> pageList = experimentSampleInfoService.listSampleBatch();
        return Result.OK(pageList);
    }

    @Operation(summary = "试验样品信息-分页列表名称型号")
    @GetMapping(value = "/listSampleName")
    public Result<List<ExperimentSampleInfo>> listSampleName(HttpServletRequest req) {
        List<ExperimentSampleInfo> pageList = experimentSampleInfoService.listSampleName();
        return Result.OK(pageList);
    }

    @Operation(summary = "试验样品信息-列表查询")
    @GetMapping(value = "/search")
    public Result<List<ExperimentSampleInfo>> search(ExperimentSampleInfo experimentSampleInfo, HttpServletRequest req) {
        Map<String, QueryRuleEnum> customeRuleMap = new HashMap<>();
        // 自定义 sampleModel 字段的查询规则为：RIGHT_LIKE
        customeRuleMap.put("sampleModel", QueryRuleEnum.RIGHT_LIKE);
        customeRuleMap.put("sampleType", QueryRuleEnum.RIGHT_LIKE);
        customeRuleMap.put("sampleName", QueryRuleEnum.RIGHT_LIKE);
        QueryWrapper<ExperimentSampleInfo> queryWrapper = QueryGenerator.initQueryWrapper(experimentSampleInfo, req.getParameterMap(),
                customeRuleMap);
        List<ExperimentSampleInfo> pageList = experimentSampleInfoService.list(queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param experimentSampleInfo
     * @return
     */
    @AutoLog(value = "试验样品信息-添加")
    @Operation(summary = "试验样品信息-添加")
    @RequiresPermissions("database:experiment:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody ExperimentSampleInfo experimentSampleInfo) {
        experimentSampleInfoService.save(experimentSampleInfo);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param experimentSampleInfo
     * @return
     */
    @AutoLog(value = "试验样品信息-编辑")
    @Operation(summary = "试验样品信息-编辑")
    @RequiresPermissions("database:experiment:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody ExperimentSampleInfo experimentSampleInfo) {
        experimentSampleInfoService.updateById(experimentSampleInfo);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "试验样品信息-通过id删除")
    @Operation(summary = "试验样品信息-通过id删除")
    @RequiresPermissions("database:experiment:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        experimentSampleInfoService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "试验样品信息-批量删除")
    @Operation(summary = "试验样品信息-批量删除")
    @RequiresPermissions("database:experiment:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.experimentSampleInfoService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "试验样品信息-通过id查询")
    @Operation(summary = "试验样品信息-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ExperimentSampleInfo> queryById(@RequestParam(name = "id", required = true) String id) {
        ExperimentSampleInfo experimentSampleInfo = experimentSampleInfoService.getById(id);
        if (experimentSampleInfo == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(experimentSampleInfo);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param experimentSampleInfo
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ExperimentSampleInfo experimentSampleInfo) {
        return super.exportXls(request, experimentSampleInfo, ExperimentSampleInfo.class, "试验样品信息");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:experiment:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ExperimentSampleInfo.class);
    }

}
